function init(hero) {
    hero.setName("Adam Warlock");
    hero.setVersion ("Comics");
    hero.setTier(9);

    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("fiskheroes:cosmic_physiology", "fiskheroes:energy_manipulation", "fiskheroes:flight", "soulhp:size_differing");
    hero.addAttribute("MAX_HEALTH", 5.0, 0);
    hero.addAttribute("PUNCH_DAMAGE", 11.25, 0);
    hero.addAttribute("SPRINT_SPEED", 2.0, 1);
    hero.addAttribute("KNOCKBACK", 2.0, 0);
	
    hero.addKeyBind("SIZE_MANIPULATION", "key.sizeManipulation", 4)
	hero.addKeyBindFunc("func_GIANT_MODE", giantModeKey, "key.giantMode", 5);
    hero.addKeyBind("CHARGE_ENERGY", "key.chargeEnergy", 1);
    hero.addKeyBind("TELEPORT", "key.teleport", 2);
	hero.addKeyBind("TELEKINESIS", "key.telekinesis", 3);
	
	hero.addAttributeProfile("GIANT_MODE", giantProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
	hero.setHasProperty(hasProperty);
}
		
function giantModeKey(player, manager) {
    var flag = player.getData("fiskheroes:dyn/giant_mode");
    manager.setData(player, "fiskheroes:dyn/giant_mode", !flag);
    manager.setData(player, "fiskheroes:size_state", flag ? -1 : 1);
    return true;
}


function giantProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 18.25, 0);
    profile.addAttribute("JUMP_HEIGHT", 2.0, 0);
    profile.addAttribute("FALL_RESISTANCE", 4.0, 0);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:dyn/giant_mode_timer") > 0 ? "GIANT_MODE" : null;
}

function isModifierEnabled(entity, modifier) {
    return modifier.name() != "fiskheroes:size_manipulation" || (modifier.id() == "giant") == (entity.getData("fiskheroes:dyn/giant_mode_timer") > 0 || entity.getData("fiskheroes:dyn/giant_mode"));
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "func_GIANT_MODE":
        return entity.getData("fiskheroes:size_state") == 0 && (entity.getData("fiskheroes:dyn/giant_mode") || entity.getData("fiskheroes:dyn/giant_mode_cooldown") == 0);
    case "SIZE_MANIPULATION":
        return !entity.getData("fiskheroes:dyn/giant_mode");
    default:
        return true;
    }
}

		
function hasProperty(entity, property) {
    return property == "BREATHE_SPACE";
}